--- m3dapi.lua

local nscrm3d = require 'nscrm3d'

local m3d

local function pop_arg(typ)
  if typ == "s" then
    return NSPopStr()
  elseif typ == "i" then
    return NSPopInt()
  elseif typ == "#" then
    return NSPopID()
  elseif typ == "$" then
    return NSPopStrRef()
  elseif typ == "%" then
    return NSPopIntRef()
  else
    return nil
  end
end


local function pop_args(pat)
  if not pat or #pat == 0 then return nil end
  if pat == "{kv}" then
    local vars = {}
    vars[NSPopID()] = NSPopComma() or NSPopInt()
    while NSCheckComma() do
      NSPopComma()
      vars[NSPopID()] = NSPopComma() or NSPopInt()
    end
    return vars
  end
  local params = {}
  local buf = pat
  table.insert(params, pop_arg(pat:sub(1, 1)))
  buf = pat:sub(2)
  while NSCheckComma() and #buf > 0 do
    local typ = buf:match("^[si#%$%%]")
    if typ then
      if #params ~= 0 then NSPopComma() end
      table.insert(params, pop_arg(typ))
    end
    buf = buf:sub(2)
  end
  return unpack(params)
end


local function def(name, pattern)
  _G['NSCOM_' .. name] = function()
    m3d[name](m3d, pop_args(pattern))
  end
  NSExec('luasub ' .. name)
end


for name, pattern in pairs{
  lm3d = 'isiiii',
  cm3d = 'i',
  vm3d = 'ii',
  mm3d = 'iiiii',
  amm3d = 'iiiii',
  rm3d = 'iiiii',
  arm3d = 'iiiii',
  m3drender = "i",
  m3dtrace = "i",
  m3dcameraset = "{kv}",
  m3dcameraadd = "{kv}",
  m3dcamerareset = "",
  m3dmotionload = "is",
  m3dmotionclear = "i",
  m3dmotionplay = "i",
  m3dmotionstop = "i",
} do
  def(name, pattern)
end


module('m3dapi')

-- for singleton
function init(swfInstance)
  m3d = nscrm3d.new(swfInstance)
end
