package  {
	import away3dlite.cameras.HoverCamera3D;
	import away3dlite.containers.View3D;
	import flash.geom.Point;
	/**
	 * ...
	 * @author senzogawa
	 */
	public class CameraController {
		private var _view:View3D;
		private var _camera:HoverCamera3D;
		private var _defaultVars:Object;
		private var _defaultPoint:Point;
		
		public function CameraController(view:View3D) {
			this._view = view;
			this._camera = view.camera as HoverCamera3D;
			_defaultVars = new Object();
			for each(var name:String in ["panAngle", "tiltAngle", "zoom", "focus", "distance"]) {
				_defaultVars[name] = _camera[name];
			}
			_defaultPoint = new Point(_view.x, _view.y);
		}
		
		public function setVars(vars:Object):Boolean {
			if (vars == null) return false;
			if (vars.panAngle != undefined) _camera.panAngle = vars.panAngle;
			if (vars.tiltAngle != undefined) _camera.tiltAngle = vars.tiltAngle;
			if (vars.panangle != undefined) _camera.panAngle = vars.panangle;
			if (vars.tiltangle != undefined) _camera.tiltAngle = vars.tiltangle;
			if (vars.zoom != undefined) _camera.zoom = vars.zoom;
			if (vars.focus != undefined) _camera.focus = vars.focus;
			if (vars.distance != undefined) _camera.distance = vars.distance;
			if (vars.x != undefined) _view.x = vars.x;
			if (vars.y != undefined) _view.y = vars.y;
			logVars();
			return true;
		}
		
		public function addVars(vars:Object):Boolean {
			if (vars == null) return false;
			if (vars.panAngle != undefined) _camera.panAngle += vars.panAngle;
			if (vars.tiltAngle != undefined) _camera.tiltAngle += vars.tiltAngle;
			if (vars.panangle != undefined) _camera.panAngle += vars.panangle;
			if (vars.tiltangle != undefined) _camera.tiltAngle += vars.tiltangle;
			if (vars.zoom != undefined) _camera.zoom += vars.zoom;
			if (vars.focus != undefined) _camera.focus += vars.focus;
			if (vars.distance != undefined) _camera.distance += vars.distance;
			if (vars.x != undefined) _view.x -= vars.x;
			if (vars.y != undefined) _view.y -= vars.y;
			logVars();
			return true;
		}
		
		private function logVars():void {
			Log.i("camera: x,y,pan,tilt,zoom,focus = " + 
				[_defaultPoint.x - _view.x, _defaultPoint.y - _view.y, 
				_camera.panAngle, _camera.tiltAngle, _camera.zoom, _camera.focus].join(","));
		}
		
		public function getVars():Object {
			return {
				x : _defaultPoint.x - _view.x,
				y : _defaultPoint.y - _view.y,
				panAngle : _camera.panAngle,
				tiltAngle : _camera.tiltAngle,
				zoom : _camera.zoom,
				focus : _camera.focus,
				distance : _camera.distance
			}
		}
		
		public function reset():void {
			_view.x = _defaultPoint.x;
			_view.y = _defaultPoint.y;
			for (var name:String in _defaultVars) {
				_camera[name] = _defaultVars[name];
			}
			logVars();
		}
		
		public function dispatchCommand(command:String, args:Object):*{
			switch(command) {
			case "setVars":
				return setVars(args.vars);
			case "addVars":
				return addVars(args.vars);
			case "getVars":
				return getVars();
			case "reset":
				reset();
				return true;
			}
			return null;
		}
	}

}