package  {
	import away3dlite.cameras.HoverCamera3D;
	import away3dlite.containers.Scene3D;
	import away3dlite.containers.View3D;
	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	/**
	 * ...
	 * @author senzogawa
	 */
	public class Engine {
		public static const DEFAULT_FRAME_RATE:Number = 1.0 / 30.0;
		public static const DEFAULT_STEPS:Number = 8;
		
		public var view:View3D;
		public var camera:HoverCamera3D;
		
		public static const RENDER_EVERYFRAME:int = -1;
		public static const RENDER_NOFRAME:int = 0;
		public static const RENDER_ONCE:int = 1;
		private var _renderOn:Number = RENDER_NOFRAME;
		
		public function Engine(owner:DisplayObjectContainer) {
			view = new View3D();
			view.x = owner.stage.stageWidth / 2;
			view.y = owner.stage.stageHeight / 2;
			view.scene = new Scene3D();
			camera = new HoverCamera3D();
			camera.distance = 2;
			camera.steps = DEFAULT_FRAME_RATE;
			view.camera = camera;
			
			owner.addChild(view);
		}
		
		public function onEnterFrame(event:Event):void {
			switch(_renderOn) {
			case RENDER_NOFRAME:
				return;
			case RENDER_ONCE:
				_renderOn = RENDER_NOFRAME;
				break;
			}
			camera.hover(_renderOn == RENDER_ONCE);
			view.render();
		}
		
		public function set renderOn(value:Number):void {
			if (_renderOn != value) {
				switch(value) {
				case RENDER_ONCE:
					camera.steps = DEFAULT_FRAME_RATE;
					break;
				case RENDER_EVERYFRAME:
					camera.steps = DEFAULT_STEPS;
					break;
				}
			}
			_renderOn = value;
		}
		
	}

}