package  {
	/**
	 * ...
	 * @author senzogawa
	 */
	public class Log {
		private static var labels:Vector.<String> = Vector.<String>(["", "V", "D", "I", "W", "E", "A"]);
		
		public static const ASSERT:int = 6;
		public static const ERROR:int = 5;
		public static const WARN:int = 4;
		public static const INFO:int = 3;
		public static const DEBUG:int = 2;
		public static const VERBOSE:int = 1;
		public static const ALL:int = 0;
		
		public static var loglevel:int = CONFIG::loglevel;
		public static var tracer:Function = trace;
		
		public static function e(...args):void {
			print(ERROR, args);
		}
		
		public static function w(...args):void {
			print(WARN, args);
		}
		
		public static function i(...args):void {
			print(INFO, args);
		}
		
		public static function d(...args):void {
			print(DEBUG, args);
		}
		
		public static function v(...args):void {
			print(VERBOSE, args);
		}
		
		public static function print(level:int, ...args):void {
			if (loglevel > level) return;
			args.unshift(labels[level]);
			tracer.apply(null, args);
		}
	}

}