package net.gamekotan.mmd {
	import flash.geom.Vector3D;
	/**
	 * ...
	 * @author senzogawa
	 */
	public class MMDMorphMotion {
		
		public var name:String;
		public var morphs:Vector.<VMDMorph>;
		
		public function MMDMorphMotion(name:String) {
			this.name = name;
			morphs = new Vector.<VMDMorph>();
		}
		
		public function sort():void {
			// Sort Ascendant
			morphs.sort(function(one:VMDMorph, another:VMDMorph):Number {
				return one.frame - another.frame;
			});
		}
		
		public function update(morph:PMDMorph, vertices:Vector.<Vector3D>, frame:int):void {
			if (morph == null) return;
			var length:int = morphs.length;
			var last:int = length - 1;
			
			var current:int;
			var next:int;
			if (frame >= morphs[last].frame) {
				current = next = last;
			}
			else if (frame <= morphs[0].frame) {
				current = next = 0;
			}
			else {
				next = last;
				for (var i:int = 0; i < length; i++) {
					if (frame <= morphs[i].frame) {
						next = i;
						break;
					}
				}
				current = Math.max(0, next - 1);
			}
			var currentMorph:VMDMorph = morphs[current];
			var nextMorph:VMDMorph = morphs[next];
			var ratio:Number;
			if (current != next) {
				var lerp:Number = (frame - currentMorph.frame) / (nextMorph.frame - currentMorph.frame);
				ratio = currentMorph.factor * (1.0 - lerp) + (nextMorph.factor * lerp);
			}
			else {
				ratio = currentMorph.factor;
			}
			if (ratio >= 1.0) {
				morph.setTo(vertices);
			}
			else {
				morph.blendTo(vertices, ratio);
			}
		}
	}

}