package net.gamekotan.mmd {
	import flash.geom.Vector3D;
	/**
	 * ...
	 * @author senzogawa
	 */
	public class PMDMorph {
		public var name:String;
		public var verticesWithIndex:Vector.<Vector3D>; // wはindexとして使う。
		
		public function PMDMorph(name:String, verticesWithIndex:Vector.<Vector3D>) {
			this.name = name;
			this.verticesWithIndex = verticesWithIndex;
		}
		
		public function verticesToWorld(base:PMDMorph):void {
			// ベースの相対から絶対へ変更。
			var baseVerticesWithIndex:Vector.<Vector3D> = base.verticesWithIndex;
			for each(var vertexWithIndex:Vector3D in verticesWithIndex) {
				var index:int = vertexWithIndex.w;
				vertexWithIndex.incrementBy(baseVerticesWithIndex[index]);
				vertexWithIndex.w = baseVerticesWithIndex[index].w;
			}
		}
		
		public function setTo(vertices:Vector.<Vector3D>):void {
			for each(var vertexWithIndex:Vector3D in verticesWithIndex) {
				var vartex:Vector3D = vertices[int(vertexWithIndex.w)];
				vartex.x = vertexWithIndex.x;
				vartex.y = vertexWithIndex.y;
				vartex.z = vertexWithIndex.z;
			}
		}
		
		public function blendTo(vertices:Vector.<Vector3D>, ratio:Number):void {
			for each(var vertexWithIndex:Vector3D in verticesWithIndex) {
				var vartex:Vector3D = vertices[int(vertexWithIndex.w)];
				lerpVector3D(vartex, vertexWithIndex, ratio);
			}
		}
		
		private static function lerpVector3D(one:Vector3D, another:Vector3D, lerp:Number):void {
			var t:Number = 1.0 - lerp;
			one.x = one.x * t + another.x * lerp;
			one.y = one.y * t + another.y * lerp;
			one.z = one.z * t + another.z * lerp;
		}
	
	}

}